## python-autobahn 22.7.1+dfsg1

=== Makefile ===
.PHONY: test docs pep8 build

WHEELS=https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels
XBRNETWORK=${HOME}/.local/bin/xbrnetwork

all:
	@echo "Targets:"
	@echo ""
	@echo "   clean            Cleanup"
	@echo "   install          Local install"
	@echo "   publish          Clean build, register and publish to PyPi"
	@echo "   test             Run unit tests"
	@echo "   flake8           Run flake8 code checking"
	@echo ""

# deprecated with v21.2.1 (ABI files are no longer bundled in this package)
abi_files:
	curl -s https://xbr.network/lib/abi/xbr-protocol-latest.zip -o /tmp/xbr-protocol-latest.zip
	unzip -t /tmp/xbr-protocol-latest.zip
	rm -rf ${PWD}/autobahn/xbr/contracts
	unzip /tmp/xbr-protocol-latest.zip -d ${PWD}/autobahn/xbr/contracts

# install locally
install:
	-pip uninstall -y pytest_asyncio # remove the broken shit
	-pip uninstall -y pytest_cov # remove the broken shit
	# enforce use of bundled libsodium
	AUTOBAHN_USE_NVX=1 SODIUM_INSTALL=bundled pip install -e .[all]

build:
	-rm -f dist/*
	# AUTOBAHN_USE_NVX=0 python setup.py sdist --universal
	AUTOBAHN_USE_NVX=1 python setup.py sdist
	ls -la dist

# upload to our internal deployment system
upload: clean
	AUTOBAHN_USE_NVX=0 python setup.py sdist --universal
	aws s3 cp --acl public-read \
		dist/autobahn-*.whl \
		s3://fabric-deploy/autobahn/

# cleanup everything
clean: clean_docs clean_catalog
	-rm -f ./*.so
	-rm -rf ./docs/build
	-rm -rf ./.cache
	-rm -rf ./autobahn.egg-info
	-rm -rf ./build
	-rm -rf ./dist
	-rm -rf ./temp
	-rm -rf ./_trial_temp
	-rm -rf ./.tox
	-rm -rf ./.eggs
	-rm -rf ./htmlcov
	-rm -f ./.coverage
	-rm -f ./coverage.xml
	-rm -f ./.coverage.*
	-rm -rf ~/coverage
	-rm -f  ./twisted/plugins/dropin.cache
	-find . -name "*dropin.cache.new" -type f -exec rm -f {} \;
	-find . -name ".pytest_cache" -type d -exec rm -rf {} \;
	-find . -name "*.tar.gz" -type f -exec rm -f {} \;
	-find . -name "*.egg" -type f -exec rm -f {} \;
	-find . -name "*.pyc" -type f -exec rm -f {} \;

	# Learn to love the shell! http://unix.stackexchange.com/a/115869/52500
	-find . \( -name "*__pycache__" -type d \) -prune -exec rm -rf {} +

clean_catalog:
	cd ./autobahn/xbr/test/catalog && make clean

rebuild_catalog:
	cd ./autobahn/xbr/test/catalog && make distclean && make build

# publish to PyPI
publish: clean
	AUTOBAHN_USE_NVX=0 python setup.py sdist
	twine upload dist/*

clean_docs:
	-rm -rf ./docs/_build

docs:
	tox -e sphinx

spelling:
	cd docs && sphinx-build -b spelling . _spelling

run_docs:
	twistd --nodaemon web --port=tcp:8090 --path=./docs/_build/


clean_wheels:
	rm -rf ./.wheels
	mkdir -p ./.wheels/

download_wheels:
	mkdir -p ./.wheels/
	rm -f ./.wheels/*.whl
	curl -o ./.wheels/txaio-latest-py2.py3-none-any.whl 	$(WHEELS)/txaio-latest-py2.py3-none-any.whl
	curl -o ./.wheels/zlmdb-latest-py2.py3-none-any.whl 	$(WHEELS)/zlmdb-latest-py2.py3-none-any.whl
	curl -o ./.wheels/xbr-latest-py2.py3-none-any.whl 		$(WHEELS)/xbr-latest-py2.py3-none-any.whl
	curl -o ./.wheels/autobahn-latest-py2.py3-none-any.whl 	$(WHEELS)/autobahn-latest-py2.py3-none-any.whl
	ls -la ./.wheels

build_this_wheel:
	mkdir -p ./.wheels/
	rm -f ./.wheels/autobahn*.whl
	pip3 wheel --no-deps --wheel-dir=./.wheels .
	mv .wheels/autobahn*.whl .wheels/autobahn-latest-py2.py3-none-any.whl
	ls -la ./.wheels

download_exe:
	curl -o $(XBRNETWORK) \
		https://download.crossbario.com/xbrnetwork/linux-amd64/xbrnetwork-latest
	chmod +x $(XBRNETWORK)
	$(XBRNETWORK) version

build_exe:
	tox -e buildexe

upload_exe:
	aws s3 cp --acl public-read \
		./dist/xbrnetwork \
		s3://download.crossbario.com/xbrnetwork/linux-amd64/${XBRNETWORK_EXE_FILENAME}
	aws s3 cp --acl public-read \
		./dist/xbrnetwork \
		s3://download.crossbario.com/xbrnetwork/linux-amd64/xbrnetwork-latest
	# aws s3api copy-object --acl public-read --copy-source \
	# 	download.crossbario.com/xbrnetwork/linux-amd64/${XBRNETWORK_EXE_FILENAME} \
	# 	--bucket download.crossbario.com \
	# 	--key xbrnetwork/linux-amd64/xbrnetwork-latest
	aws cloudfront create-invalidation \
		--distribution-id E2QIG9LNGCJSP9 --paths "/xbrnetwork/linux-amd64/*"

mypy:
	mypy --install-types --non-interactive autobahn

# WEB3_INFURA_PROJECT_ID must be defined for this
test_infura:
	time -f "%e" python -c "from web3.auto.infura import w3; print(w3.isConnected())"

test_xbr:
	USE_TWISTED=1 trial autobahn.xbr

test_xbr_cli:
	xbrnetwork
	xbrnetwork version
	xbrnetwork get-member
	xbrnetwork get-market --market=1388ddf6-fe36-4201-b1aa-cb7e36b4cfb3
	xbrnetwork get-actor
	xbrnetwork get-actor --market=1388ddf6-fe36-4201-b1aa-cb7e36b4cfb3

test_xbr_schema:
	USE_TWISTED=1 trial autobahn.xbr.test.schema
	USE_ASYNCIO=1 pytest autobahn/xbr/test/schema

test_mnemonic:
	# python -m pytest -rsx autobahn/xbr/test/test_mnemonic.py
	USE_TWISTED=1 trial autobahn.xbr.test

test_nvx:
	python -m pytest -rsx autobahn/nvx/test
	USE_TWISTED=1 trial autobahn.nvx.test.test_utf8validator

test_styleguide:
	flake8 --statistics --max-line-length=119 -qq autobahn

# direct test via pytest (only here because of setuptools test integration)
test_pytest:
	USE_ASYNCIO=1 python -m pytest -c setup.cfg -rsvx autobahn/

# test via setuptools command
test_setuptools:
	python setup.py test

test:
	tox -e flake8,py37-twtrunk,py37-asyncio,coverage

#test: flake8 test_twisted test_asyncio

# test under Twisted
test_twisted:
	USE_TWISTED=1 trial autobahn
#	WAMP_ROUTER_URL="ws://127.0.0.1:8080/ws" USE_TWISTED=1 trial autobahn

test_application_runner:
	USE_TWISTED=1 trial autobahn.twisted.test.test_tx_application_runner

test_util:
	USE_TWISTED=1 trial autobahn.test.test_util

test_rng:
	USE_TWISTED=1 trial autobahn.test.test_rng

test_serializer:
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_serializer

test_wamp_identifiers:
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_identifiers

test_tx_cryptobox:
	USE_TWISTED=1 trial autobahn.wamp.test.test_cryptobox

test_tx_choosereactor:
	USE_TWISTED=1 trial autobahn.twisted.test.test_choosereactor

test_cryptosign:
#	USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_cryptosign
	USE_ASYNCIO=1 pytest -s -v -rfA --ignore=./autobahn/twisted autobahn/wamp/test/test_wamp_cryptosign.py
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_cryptosign

test_xbr_web3:
#	pytest -s -v -rfA autobahn/xbr/test/test_xbr_web3.py
	trial autobahn/xbr/test/test_xbr_web3.py

test_xbr_frealm:
#	pytest -s -v -rfA autobahn/xbr/test/test_xbr_frealm.py
	trial autobahn/xbr/test/test_xbr_frealm.py

test_wamp_scram:
	USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_scram
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_scram

test_xbr_argon2:
	USE_ASYNCIO=1 trial autobahn.xbr.test.test_xbr_argon2
	USE_TWISTED=1 trial autobahn.xbr.test.test_xbr_argon2

test_xbr_config:
	USE_TWISTED=1 trial autobahn.xbr.test.test_xbr_config

test_transport_details:
	USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_transport_details
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_transport_details

test_session_details:
	USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_session_details
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_session_details

test_tx_protocol:
	USE_TWISTED=1 trial autobahn.twisted.test.test_tx_protocol

test_twisted_coverage:
	-rm .coverage
	USE_TWISTED=1 coverage run --omit=*/test/* --source=autobahn `which trial` autobahn
#	coverage -a -d annotated_coverage
	coverage html
	coverage report --show-missing

test_coverage:
	-rm .coverage
	tox -e py27-twtrunk,py27-asyncio,py36-asyncio
	coverage combine
	coverage html
	coverage report --show-missing

# test under asyncio
test_asyncio:
	USE_ASYNCIO=1 pytest -s -v -rfP --ignore=./autobahn/twisted autobahn
#	USE_ASYNCIO=1 pytest -s -v -rA --ignore=./autobahn/twisted ./autobahn/asyncio/test/test_aio_websocket.py
#	USE_ASYNCIO=1 pytest -s -v -rA --log-cli-level=info --ignore=./autobahn/twisted ./autobahn/asyncio/test/test_aio_websocket.py


test_cs1:
	USE_ASYNCIO=1 python -m pytest -s -v autobahn/wamp/test/test_cryptosign.py

test1:
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_uri_pattern
#	USE_TWISTED=1 trial autobahn.wamp.test.test_auth
#	USE_TWISTED=1 python -m pytest -s -v autobahn/wamp/test/test_auth.py
#	USE_TWISTED=1 python -m pytest -s -v autobahn/wamp/test/test_router.py
#	USE_ASYNCIO=1 python -m pytest -s -v autobahn/wamp/test/test_router.py

test2:
#	USE_TWISTED=1 python -m pytest -s -v autobahn/wamp/test/test_router.py
	USE_ASYNCIO=1 python -m pytest -s -v autobahn/wamp/test/test_router.py
#	trial autobahn
#	trial autobahn.websocket.test
#	trial autobahn.wamp.test
#	trial autobahn.wamp.test.test_component
#	trial autobahn.wamp.test.test_message
#	trial autobahn.wamp.test.test_protocol
#	trial autobahn.wamp.test.test_protocol_peer
#	trial autobahn.wamp.test.test_serializer
#	trial autobahn.wamp.test.test_uri_pattern

pyflakes:
	pyflakes .

# run PEP8 check and print statistics
pep8:
	pep8 --statistics --ignore=E501 -qq autobahn

# run PEP8 check and show source for offending code
pep8show:
	pep8 --show-source --ignore=E501 autobahn

# run autopep8 to automatically transform offending code
autopep8:
	autopep8 -ri --aggressive autobahn

# This will run pep8, pyflakes and can skip lines that end with # noqa
flake8:
	flake8 --ignore=E402,E501,E722,E741,N801,N802,N803,N805,N806,N815 \
	    --exclude "autobahn/wamp/message_fbs.py,autobahn/wamp/gen/*"\
	    autobahn

# run PyLint
pylint:
	pylint -d line-too-long,invalid-name autobahn

# on Unix, check for files with Windows line endings
find_windows_files:
	find . -name "*" -exec file {} \; | grep "CRLF"

# on Windows (Git Bash), check for files with Unix lines endings
find_unix_files:
	find . -name "*" -exec dos2unix -tv {} \; 2>&1 | grep "Unix"

# sudo apt install gource ffmpeg
gource:
	gource \
	--path . \
	--seconds-per-day 0.15 \
	--title "autobahn-python" \
	-1280x720 \
	--file-idle-time 0 \
	--auto-skip-seconds 0.75 \
	--multi-sampling \
	--stop-at-end \
	--highlight-users \
	--hide filenames,mouse,progress \
	--max-files 0 \
	--background-colour 000000 \
	--disable-bloom \
	--font-size 24 \
	--output-ppm-stream - \
	--output-framerate 30 \
	-o - \
	| ffmpeg \
	-y \
	-r 60 \
	-f image2pipe \
	-vcodec ppm \
	-i - \
	-vcodec libx264 \
	-preset ultrafast \
	-pix_fmt yuv420p \
	-crf 1 \
	-threads 0 \
	-bf 0 \
	autobahn-python.mp4

#
# generate (a special set of) WAMP message classes from FlatBuffers schema
#

# input .fbs files for schema
FBSFILES=./autobahn/wamp/flatbuffers/*.fbs

# flatc compiler to use
FLATC=flatc

clean_fbs:
	-rm -rf ./autobahn/wamp/gen/

build_fbs:
	# generate schema type library (*.bfbs files)
	$(FLATC) -o ./autobahn/wamp/gen/schema/ --binary --schema --bfbs-comments --bfbs-builtins $(FBSFILES)
	@find ./autobahn/wamp/gen/schema/ -name "*.bfbs" | wc -l

	# generate schema Python bindings (*.py files)
	$(FLATC) -o ./autobahn/wamp/gen/ --python $(FBSFILES)
	@find ./autobahn/wamp/gen/ -name "*.py" | wc -l

	# generate schema C++ bindings (*.cpp/hpp files)
	# $(FLATC) -o /tmp/gen/ --cpp $(FBSFILES)
	# @find /tmp/gen/

=== docker/Makefile ===
WHEELS=https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels

default:
	@echo ""
	@echo "Targets:"
	@echo ""
	@echo "  params                 Print build parameters"
	@echo "  build                  Build images"
	@echo "  test                   Test images"
	@echo "  publish                Publish images"
	@echo ""

params:
	@echo ""
	@echo "Build environment configured:"
	@echo ""
	@echo "${AUTOBAHN_BUILD_DATE}"
	@echo "${AUTOBAHN_BUILD_ID}"
	@echo "${AUTOBAHN_VCS_REF}"
	@echo "${AUTOBAHN_VERSION}"
	@echo ""


install_qemu:
	sudo apt-get update
	sudo apt-get install -y qemu qemu-kvm qemu-system qemu-system-x86 qemu-system-arm
	sudo apt-get install -y --no-install-recommends qemu-user-static binfmt-support
	sudo update-binfmts --enable qemu-arm
	sudo update-binfmts --enable qemu-aarch64
	sudo update-binfmts --display qemu-arm
	sudo update-binfmts --display qemu-aarch64

copy_qemu:
	mkdir -p ./.qemu
	cp /usr/bin/qemu-aarch64-static ./.qemu
	cp /usr/bin/qemu-arm-static ./.qemu


clean_wheels:
	rm -rf ./.wheels
	mkdir -p ./.wheels/

clean_docker:
	-docker images | grep "crossbario/autobahn-python" | awk '{print $1}' | xargs docker rmi


download_wheels:
	mkdir -p ./.wheels/
	rm -f ./.wheels/*.whl
	curl -o ./.wheels/txaio-latest-py2.py3-none-any.whl 	$(WHEELS)/txaio-latest-py2.py3-none-any.whl
	curl -o ./.wheels/zlmdb-latest-py2.py3-none-any.whl 	$(WHEELS)/zlmdb-latest-py2.py3-none-any.whl
	curl -o ./.wheels/xbr-latest-py2.py3-none-any.whl 		$(WHEELS)/xbr-latest-py2.py3-none-any.whl
	curl -o ./.wheels/autobahn-latest-py2.py3-none-any.whl 	$(WHEELS)/autobahn-latest-py2.py3-none-any.whl
	ls -la ./.wheels

build_this_wheel:
	mkdir -p ./.wheels/
	rm -f ./.wheels/autobahn*.whl
	pip3 wheel --no-deps --wheel-dir=./.wheels ..
	mv .wheels/autobahn*.whl .wheels/autobahn-latest-py2.py3-none-any.whl
	ls -la ./.wheels


# WARNING: this will stop and remove all containers on the local host!
docker_stop_rm:
	-docker stop $(docker ps -a -q)
	-docker rm $(docker ps -a -q -f)


show:
	@echo
	@echo
	@echo "autobahn build configuration -------------------------------------------------------------------------------------------"
	@echo
	@echo "  AUTOBAHN_BUILD_DATE     = ${AUTOBAHN_BUILD_DATE}"
	@echo "  AUTOBAHN_BUILD_ID       = ${AUTOBAHN_BUILD_ID}"
	@echo "  AUTOBAHN_VCS_REF        = ${AUTOBAHN_VCS_REF}"
	@echo "  AUTOBAHN_VERSION        = ${AUTOBAHN_VERSION}"
	@echo ""
	@echo "  XBRNETWORK_EXE_FILENAME = ${XBRNETWORK_EXE_FILENAME}"
	@echo


build: build_cpy build_pypy

test: test_cpy test_pypy

publish: publish_cpy publish_pypy

list: list_cpy list_pypy


build_amd64: build_cpy_amd64 build_pypy_amd64

test_amd64: test_cpy_amd64 test_pypy_amd64

publish_amd64: publish_cpy_amd64 publish_pypy_amd64

list_amd64: list_cpy_amd64 list_pypy_amd64


build_arm64v8: build_cpy_arm64v8 build_pypy_arm64v8

test_arm64v8: test_cpy_arm64v8 test_pypy_arm64v8

publish_arm64v8: publish_cpy_arm64v8 publish_pypy_arm64v8

list_arm64v8: list_cpy_arm64v8 list_pypy_arm64v8


build_cpy: build_cpy_amd64 build_cpy_arm64v8

test_cpy: test_cpy_amd64 test_cpy_arm64v8

publish_cpy: publish_cpy_amd64 publish_cpy_arm64v8

list_cpy: list_cpy_amd64 list_cpy_arm64v8


build_pypy: build_pypy_amd64 build_pypy_arm64v8

test_pypy: test_pypy_amd64 test_pypy_arm64v8

publish_pypy: publish_pypy_amd64 publish_pypy_arm64v8

list_pypy: list_pypy_amd64 list_pypy_arm64v8


build_cpy_amd64:
	docker build \
		--build-arg AUTOBAHN_ARCH=amd64 \
		--build-arg AUTOBAHN_BUILD_ID=${AUTOBAHN_BUILD_ID} \
		--build-arg AUTOBAHN_BUILD_DATE=${AUTOBAHN_BUILD_DATE} \
		--build-arg AUTOBAHN_VCS_REF=${AUTOBAHN_VCS_REF} \
		--build-arg AUTOBAHN_VERSION=${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:cpy-amd64 \
		-t crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		-f Dockerfile.cpy-slim .
	docker images crossbario/autobahn-python:cpy-amd64

test_cpy_amd64:
	docker run --rm crossbario/autobahn-python:cpy-amd64

publish_cpy_amd64:
	docker push crossbario/autobahn-python:cpy-amd64
	docker push crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}
	docker push crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}

list_cpy_amd64:
	@echo
	@echo "autobahn-python:cpy-amd64 ----------------------------------------------------------------------------------------------"
	@echo
	@docker inspect --format='{{index .RepoDigests 0}}' crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}
	@echo
	@docker images crossbario/autobahn-python:cpy-amd64
	@docker images crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}
	@docker images crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}
	@docker images `docker inspect --format='{{index .RepoDigests 0}}' crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}`


build_cpy_arm64v8:
	docker build \
		--build-arg AUTOBAHN_ARCH=arm64v8 \
		--build-arg AUTOBAHN_BUILD_ID=${AUTOBAHN_BUILD_ID} \
		--build-arg AUTOBAHN_BUILD_DATE=${AUTOBAHN_BUILD_DATE} \
		--build-arg AUTOBAHN_VCS_REF=${AUTOBAHN_VCS_REF} \
		--build-arg AUTOBAHN_VERSION=${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:cpy-arm64v8 \
		-t crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		-f ./Dockerfile.cpy-slim .
	docker images crossbario/autobahn-python:cpy-arm64v8

test_cpy_arm64v8:
	docker run --rm crossbario/autobahn-python:cpy-arm64v8

publish_cpy_arm64v8:
	docker push crossbario/autobahn-python:cpy-arm64v8
	docker push crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}
	docker push crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}

list_cpy_arm64v8:
	@echo
	@echo
	@echo "autobahn-python:cpy-arm64v8 --------------------------------------------------------------------------------------------"
	@echo
	@docker inspect --format='{{index .RepoDigests 0}}' crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}
	@echo
	@docker images crossbario/autobahn-python:cpy-arm64v8
	@docker images crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}
	@docker images crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}
	@docker images `docker inspect --format='{{index .RepoDigests 0}}' crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}`


build_pypy_amd64:
	docker build \
		--build-arg AUTOBAHN_ARCH=amd64 \
		--build-arg AUTOBAHN_BUILD_ID=${AUTOBAHN_BUILD_ID} \
		--build-arg AUTOBAHN_BUILD_DATE=${AUTOBAHN_BUILD_DATE} \
		--build-arg AUTOBAHN_VCS_REF=${AUTOBAHN_VCS_REF} \
		--build-arg AUTOBAHN_VERSION=${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:pypy-amd64 \
		-t crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		-f Dockerfile.pypy-slim .
	docker images crossbario/autobahn-python:pypy-amd64

test_pypy_amd64:
	docker run --rm crossbario/autobahn-python:pypy-amd64

publish_pypy_amd64:
	docker push crossbario/autobahn-python:pypy-amd64
	docker push crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}
	docker push crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}

list_pypy_amd64:
	@echo
	@echo
	@echo "autobahn-python:pypy-amd64 --------------------------------------------------------------------------------------------"
	@echo
	@docker inspect --format='{{index .RepoDigests 0}}' crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}
	@echo
	@docker images crossbario/autobahn-python:pypy-amd64
	@docker images crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}
	@docker images crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}
	@docker images `docker inspect --format='{{index .RepoDigests 0}}' crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}`


build_pypy_arm64v8:
	docker build \
		--build-arg AUTOBAHN_ARCH=arm64v8 \
		--build-arg AUTOBAHN_BUILD_ID=${AUTOBAHN_BUILD_ID} \
		--build-arg AUTOBAHN_BUILD_DATE=${AUTOBAHN_BUILD_DATE} \
		--build-arg AUTOBAHN_VCS_REF=${AUTOBAHN_VCS_REF} \
		--build-arg AUTOBAHN_VERSION=${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:pypy-arm64v8 \
		-t crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		-f ./Dockerfile.pypy-slim .
	docker images crossbario/autobahn-python:pypy-arm64v8

test_pypy_arm64v8:
	docker run --rm crossbario/autobahn-python:pypy-arm64v8

publish_pypy_arm64v8:
	docker push crossbario/autobahn-python:pypy-arm64v8
	docker push crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}
	docker push crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}

list_pypy_arm64v8:
	@echo
	@echo
	@echo "autobahn-python:pypy-arm64v8 ------------------------------------------------------------------------------------------"
	@echo
	@docker inspect --format='{{index .RepoDigests 0}}' crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}
	@echo
	@docker images crossbario/autobahn-python:pypy-arm64v8
	@docker images crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}
	@docker images crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}
	@docker images `docker inspect --format='{{index .RepoDigests 0}}' crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}`

# Docker multi-arch manifest
#
# https://docs.docker.com/engine/reference/commandline/manifest/
# https://docs.docker.com/docker-for-mac/multi-arch/
# https://www.docker.com/blog/multi-arch-build-and-images-the-simple-way/
# https://docs.docker.com/registry/spec/manifest-v2-2/
#
# Use the following options for different CPU archs:
#
#	--os linux --arch amd64
#	--os linux --arch 386
#	--os linux --arch arm64 --variant armv8
#	--os linux --arch arm
#
# Older Docker CLI needs: export DOCKER_CLI_EXPERIMENTAL=enabled
#
publish_manifest: publish_cpy_manifest publish_pypy_manifest

publish_cpy_manifest:
	docker manifest create --amend \
		crossbario/autobahn-python:cpy \
		crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \

	docker manifest annotate \
		crossbario/autobahn-python:cpy \
		crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		--os linux --arch amd64

	docker manifest annotate \
		crossbario/autobahn-python:cpy \
		crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		--os linux --arch arm64 --variant armv8

	docker manifest inspect \
		crossbario/autobahn-python:cpy

	docker manifest push --purge \
		crossbario/autobahn-python:cpy

publish_pypy_manifest:
	docker manifest create --amend \
		crossbario/autobahn-python:pypy \
		crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \

	docker manifest annotate \
		crossbario/autobahn-python:pypy \
		crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		--os linux --arch amd64

	docker manifest annotate \
		crossbario/autobahn-python:pypy \
		crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		--os linux --arch arm64 --variant armv8

	docker manifest inspect \
		crossbario/autobahn-python:pypy

	docker manifest push --purge \
		crossbario/autobahn-python:pypy

=== examples/twisted/websocket/echo_site/Makefile ===
test:
	PYTHONPATH=../../../../autobahn python server.py

=== debian/changelog ===
python-autobahn (22.7.1+dfsg1-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Fri, 23 Sep 2022 12:18:11 +0200

python-autobahn (22.7.1+dfsg1-1) experimental; urgency=medium

  * New upstream release.
  * Do not set USE_TWISTED=0 when running tests.
  * Add autopkgtest.

 -- Thomas Goirand <zigo@debian.org>  Mon, 19 Sep 2022 15:02:35 +0200

=== debian/control ===
Source: python-autobahn
Section: python
Priority: optional
Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
Build-Depends:
 debhelper-compat (= 10),
 dh-python,
 openstack-pkg-tools (>= 99~),
 python3-all,
 python3-setuptools,
 python3-sphinx,
 python3-sphinx-rtd-theme,
Build-Depends-Indep:
 python3-attr (>= 19.2.0),
 python3-base58,
 python3-cbor,
 python3-cffi (>= 1.11.5),
 python3-cryptography (>= 3.3.2),
 python3-ecdsa,
 python3-flatbuffers,
 python3-enchant,
 python3-hyperlink,
 python3-lz4,
 python3-mnemonic,
 python3-msgpack (>= 1.0.2),
 python3-nacl,
 python3-openssl,
 python3-passlib,
 python3-pyqrcode,
 python3-pytest (>= 6.2),
 python3-pytest-asyncio,
 python3-service-identity (>= 18.1.0),
 python3-snappy,
 python3-trie (>= 0.4.0),
 python3-twisted (>= 20.3.0),
 python3-txaio (>= 21.2.1),
 python3-u-msgpack,
 python3-ubjson,
 python3-ujson,
 python3-wsaccel,
 python3-zope.interface,
Standards-Version: 4.1.1
Vcs-Browser: https://salsa.debian.org/openstack-team/python/python-autobahn
Vcs-Git: https://salsa.debian.org/openstack-team/python/python-autobahn.git
Homepage: http://autobahn.ws/python

Package: python3-autobahn
Architecture: all
Depends:
 python3-attr (>= 19.2.0),
 python3-base58,
 python3-cbor,
 python3-cffi (>= 1.11.5),
 python3-cryptography (>= 3.3.2),
 python3-ecdsa,
 python3-flatbuffers,
 python3-hyperlink,
 python3-lz4,
 python3-mnemonic,
 python3-msgpack (>= 1.0.2),
 python3-nacl,
 python3-openssl,
 python3-passlib,
 python3-pyqrcode,
 python3-service-identity (>= 18.1.0),
 python3-snappy,
 python3-trie (>= 0.4.0),
 python3-twisted,
 python3-txaio (>= 21.2.1),
 python3-u-msgpack,
 python3-ubjson,
 python3-ujson,
 python3-wsaccel,
 python3-zope.interface,
 ${misc:Depends},
 ${python3:Depends},
Description: WebSocket client and server library, WAMP framework - Python 3.x
 Autobahn|Python is a networking library that is part of the Autobahn project
 and provides implementations of:
  * The WebSocket Protocol
  * The Web Application Messaging Protocol (WAMP)
 for Twisted and asyncio, on Python 2 & 3 and for writing servers and clients.
 .
 WebSocket allows bidirectional real-time messaging on the Web and WAMP adds
 asynchronous Remote Procedure Calls and Publish & Subscribe on top of
 WebSocket.
 .
 This package contains the Python 3.x module.

=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_GIT := https://github.com/crossbario/autobahn-python
include /usr/share/openstack-pkg-tools/pkgos.make

# Needed for tests:
export PYUBJSON_NO_EXTENSION=1
export AUTOBAHN_USE_NVX=0
export AUTOBAHN_USE_UJSON=1
export AUTOBAHN_USE_CBOR2=0
export USE_ASYNCIO=1

%:
	dh $@ --buildsystem=python_distutils --with python3

override_dh_auto_clean:
	rm -rf build .stestr
	find . -iname '*.pyc' -delete
	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done

override_dh_auto_build:
	echo "Do nothing..."

override_dh_auto_install:
	pkgos-dh_auto_install --no-py2 --in-tmp

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	set -e ; set -x ; for i in $(PYTHON3S) ; do \
		rm -rf build ; \
		PYTHONPATH=. python$$i -m pytest -Wignore -v --ignore=./autobahn/twisted --ignore=./autobahn/wamp --ignore=./autobahn/websocket --ignore=./autobahn/xbr autobahn; \
	done
endif

override_dh_clean:
	dh_clean -O--buildsystem=python_distutils
	rm -rf build twisted/plugins/dropin.cache

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

## python-autobahn 23.1.2+dfsg1

=== examples/twisted/websocket/pingpong_keepalive/Makefile ===
server:
	PYTHONPATH=../../../../autobahn python server.py

client:
	PYTHONPATH=../../../../autobahn python client.py ws://localhost:9000

=== debian/changelog ===
python-autobahn (23.1.2+dfsg1-2) unstable; urgency=medium

  * Remove depends on python3-pkg-resources (Closes: #1083599).

 -- Thomas Goirand <zigo@debian.org>  Thu, 02 Jan 2025 14:47:47 +0100

python-autobahn (23.1.2+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Removed versions of (build-)depends when satisfied in Bookworm.
  * Switch to pybuild (Closes: #1090462).
  * Blacklist test_wamp_server.

 -- Thomas Goirand <zigo@debian.org>  Thu, 19 Dec 2024 11:55:24 +0100

python-autobahn (22.7.1+dfsg1-3) unstable; urgency=medium

  * Cleans better (Closes: #1046628).

 -- Thomas Goirand <zigo@debian.org>  Fri, 18 Aug 2023 10:10:33 +0200

=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_GIT := https://github.com/crossbario/autobahn-python
include /usr/share/openstack-pkg-tools/pkgos.make

# Needed for tests:
export PYUBJSON_NO_EXTENSION=1
export AUTOBAHN_USE_NVX=0
export AUTOBAHN_USE_UJSON=1
export AUTOBAHN_USE_CBOR2=0
export USE_ASYNCIO=1

%:
	dh $@ --buildsystem=pybuild --with python3

override_dh_auto_clean:
	rm -rf twisted/plugins/dropin.cache
	rm -rf build .stestr .pytest_cache *.egg-info
	find . -iname '*.pyc' -delete
	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done

override_dh_auto_build:
	echo "Do nothing..."

override_dh_auto_install:
	pkgos-dh_auto_install --no-py2 --in-tmp

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	set -e ; set -x ; for i in $(PYTHON3S) ; do \
		rm -rf build ; \
		PYTHONPATH=. python$$i -m pytest -Wignore -v --ignore=./autobahn/twisted --ignore=./autobahn/wamp --ignore=./autobahn/websocket --ignore=./autobahn/xbr autobahn -k 'not test_wamp_server' ; \
	done
endif

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3
